
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE work.SMIX_paket.all;

ENTITY SMIX IS
 PORT
	(
		clk, reset: IN STD_LOGIC;
		rec: IN std_logic_vector(31 DOWNTO 0);
		izlaz: OUT stanje_niz
	);
END SMIX;


ARCHITECTURE shema OF SMIX IS

 BEGIN

  PROCESS(clk, reset)
    VARIABLE stanje_var: stanje_niz;
	BEGIN
	 IF (reset='1')THEN
		FOR i IN 0 TO 119 LOOP
			izlaz(i)<=X"00";
		END LOOP;
	 ELSIF (clk'EVENT AND clk='1' ) THEN
		stanje_var:= f_inicijalizacija(iv);
		tix(rec,stanje_var);
		ror3(stanje_var);
		cmix(stanje_var);
		s_box_zamena_4x4(stanje_var);
		super_mix(stanje_var);
		izlaz<= stanje_var;
	 END IF;
   END PROCESS;
			
END shema;
